package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.UserGroupService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.UserGroup;
import com.sa.ibiz.demo.demo.service.dto.UserGroupSearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/usergroup")
public class UserGroupController{



    @Autowired
	private UserGroupService usergroupService;
	/**
	 * 获取服务对象
	*/
	protected UserGroupService getService(){
		return this.usergroupService;
	}



	@PostMapping(value="main2editform/update")
	public ResponseEntity<UserGroup_EditForm_Main2> main2EditFormUpdate(@Validated @RequestBody UserGroup_EditForm_Main2 form){
            UserGroup entity =form.toUserGroup();
            getService().update(entity);
            form.fromUserGroup(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="main2editform/remove")
	public ResponseEntity<UserGroup_EditForm_Main2> main2EditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UserGroup_EditForm_Main2 form=new UserGroup_EditForm_Main2();
            UserGroup entity = new UserGroup();
            entity.setUsergroupid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromUserGroup(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/getdraft")
	public ResponseEntity<UserGroup_EditForm_Main2> main2EditFormGetDraft(@RequestBody UserGroup_EditForm_Main2 form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            UserGroup sourceEntity =new UserGroup();
            sourceEntity.setUsergroupid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			UserGroup targetEntity =new UserGroup();
			sourceEntity.copyTo(targetEntity);
			form.fromUserGroup(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            UserGroup entity =form.toUserGroup();
            getService().getDraft(entity);
            form.fromUserGroup(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="main2editform/get")
	public ResponseEntity<UserGroup_EditForm_Main2> main2EditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UserGroup_EditForm_Main2 form=new UserGroup_EditForm_Main2();
            UserGroup entity = new UserGroup();
            entity.setUsergroupid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromUserGroup(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/create")
	public ResponseEntity<UserGroup_EditForm_Main2> main2EditFormCreate(@Validated @RequestBody UserGroup_EditForm_Main2 form){
            UserGroup entity =form.toUserGroup();
            getService().create(entity);
            form.fromUserGroup(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}



	@PostMapping(value="main2grid/update")
	public UserGroup main2GridUpdate(@Validated UserGroup main2Item){
		return main2Item;
	}
	@PostMapping(value="main2grid/remove")
	public ResponseEntity<UserGroup> main2GridRemove(@Validated @RequestBody Map args){
	    UserGroup entity =new UserGroup();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setUsergroupid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public UserGroup main2GridGet(String usergroupid){
		return null;
	}
	@PostMapping(value="main2grid/getdraft")
	public UserGroup main2GridGetDraft(@Validated UserGroup main2Item){
		return main2Item;
	}
	@PostMapping(value="main2grid/create")
	public UserGroup main2GridCreate(@Validated UserGroup main2Item){
		return main2Item;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main2]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="main2grid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> main2gridExportDataSearchDefault(@Validated @RequestBody UserGroupSearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<UserGroup> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=UserGroup_Grid_Main2.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=UserGroup_Grid_Main2.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=UserGroup_Grid_Main2.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="main2grid/searchdefault")
	public ResponseEntity<Page<UserGroup_Grid_Main2>> main2GridSearchDefault(@Validated @RequestBody UserGroupSearchFilter searchFilter){
			Page<UserGroup> searchResult = this.getService().searchDefault(searchFilter);
			Page<UserGroup_Grid_Main2> searchResult_vo_data =UserGroup_Grid_Main2.fromUserGroup(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<UserGroup_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody UserGroup_SearchForm_Default searchform){
 		 
			UserGroupSearchFilter searchfilter =searchform.toUserGroupSearchFilter();
			searchform.fromUserGroupSearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }